//
//  PKCiippingView.m
//  Liquid Author
//
//  Created by Tmi Parabits on 16.8.2013.
//  Copyright (c) 2013 SoftCubicle. All rights reserved.
//

#import "PKClippingView.h"

@implementation PKClippingView

-(NSString*)text
{
    return self.textView.stringValue;
}

-(NSImage*)imageRepresentation;
{
    return [self destinationDragImage];
}

-(NSImage*)destinationDragImage
{
    return [self imageOfView:self];
}

- (NSImage *)imageOfView:(NSView*)v
{
    NSRect myRect = v.bounds;
    NSSize imgSize = myRect.size;
    
    NSBitmapImageRep *bir = [v bitmapImageRepForCachingDisplayInRect:myRect];
    [bir setSize:imgSize];
    [v cacheDisplayInRect:myRect toBitmapImageRep:bir];
    
    NSImage* image = [[NSImage alloc]initWithSize:imgSize];
    [image addRepresentation:bir];
    return image;
}

/*-(NSImage*)destinationDragImage
{
    //image to draw into
    NSImage *returnValue = [[NSImage alloc] initWithSize:NSMakeSize(125.0,  20.0)];
    
    NSString *snippetText=self.textView.stringValue;
    
    int i=20;
    
    if (i>snippetText.length)i=(int)snippetText.length;
    
    snippetText=[snippetText substringToIndex:i];
    snippetText=[NSString stringWithFormat:@"%@...", snippetText];
    
    NSPoint textLocation = NSMakePoint(0,0);
    NSShadow *textShadow = [[NSShadow alloc] init];
    [textShadow setShadowOffset:NSMakeSize(0,0)];
    [textShadow setShadowColor:[NSColor clearColor]];
    [textShadow setShadowBlurRadius:0];
    
    NSMutableDictionary *textAttributes =
    [NSMutableDictionary dictionaryWithObjectsAndKeys:
     [NSFont fontWithName:@"Georgia" size:15], NSFontAttributeName,
     [NSColor blackColor], NSForegroundColorAttributeName,
     textShadow, NSShadowAttributeName,
     nil];
    
    // find the optimal size
    CGFloat fontSize;
    NSSize testSize = NSMakeSize(0, 0);
    
    for(fontSize=1; testSize.width < [returnValue size].width; fontSize*=2)
    {
        [textAttributes setObject:[NSFont fontWithName:@"Georgia"
                                                  size:fontSize]
                           forKey:NSFontAttributeName];
        testSize = [snippetText sizeWithAttributes:textAttributes];
    }
    
    if (fontSize>24)fontSize=24;
    
    [textAttributes setObject:[NSFont fontWithName:@"Georgia"
                                              size:fontSize/2]
                       forKey:NSFontAttributeName];
    
    // and draw the text
    [returnValue lockFocus];
    
    [snippetText drawAtPoint:textLocation
              withAttributes:textAttributes];
    
    NSBezierPath *path=[NSBezierPath bezierPathWithRect:CGRectMake(0, 0, returnValue.size.width, returnValue.size.height)];
    [[NSColor blackColor]set];
    [path stroke];
    
    [returnValue unlockFocus];
    
    return returnValue;
}*/

@end
