//
//  PasteboardCommunicator.h
//  Liquid Author Test
//


#import <Foundation/Foundation.h>


@interface PasteboardCommunicator : NSObject
    <
            NSCoding
//        ,   NSPasteboardReading
        ,   NSPasteboardWriting
        ,   NSPasteboardItemDataProvider
    >
{
    NSString * _text;
    NSAttributedString * _attrText;
}

@property ( readwrite, retain ) NSString * text;
@property ( readwrite, retain ) NSAttributedString * attrText;

+ ( NSString * ) UTI;
+ ( PasteboardCommunicator * ) sharedInstance;

- ( BOOL ) writeToPasteboard: ( NSString * ) string;
- ( BOOL ) writeAttributedToPasteboard: ( NSAttributedString * ) string;

@end
